-- Test aggregation functions with decimal
-- Port from https://github.com/duckdb/duckdb/blob/main/test/sql/types/decimal/decimal_aggregates.test

SELECT arrow_typeof(FIRST_VALUE('0.1'::DECIMAL(4,1)));

-- first_value

SELECT FIRST_VALUE(NULL::DECIMAL),
    FIRST_VALUE('0.1'::DECIMAL(4,1))::VARCHAR,
    FIRST_VALUE('4938245.1'::DECIMAL(9,1))::VARCHAR,
    FIRST_VALUE('45672564564938245.1'::DECIMAL(18,1))::VARCHAR,
    FIRST_VALUE('4567645908450368043562342564564938245.1'::DECIMAL(38,1))::VARCHAR;

-- min

SELECT MIN(NULL::DECIMAL),
       MIN('0.1'::DECIMAL(4,1))::VARCHAR,
        MIN('4938245.1'::DECIMAL(9,1))::VARCHAR,
        MIN('45672564564938245.1'::DECIMAL(18,1))::VARCHAR,
        MIN('4567645908450368043562342564564938245.1'::DECIMAL(38,1))::VARCHAR;

-- max

SELECT MAX(NULL::DECIMAL),
       MAX('0.1'::DECIMAL(4,1))::VARCHAR,
        MAX('4938245.1'::DECIMAL(9,1))::VARCHAR,
        MAX('45672564564938245.1'::DECIMAL(18,1))::VARCHAR,
        MAX('4567645908450368043562342564564938245.1'::DECIMAL(38,1))::VARCHAR;

-- sum

SELECT SUM(NULL::DECIMAL),
       SUM('0.1'::DECIMAL(4,1))::VARCHAR,
        SUM('4938245.1'::DECIMAL(9,1))::VARCHAR,
        SUM('45672564564938245.1'::DECIMAL(18,1))::VARCHAR,
        SUM('4567645908450368043562342564564938245.1'::DECIMAL(38,1))::VARCHAR;

-- decimal aggregates over a table

CREATE TABLE decimals (
    d1 DECIMAL(4,1),
    d2 DECIMAL(9,1),
    d3 DECIMAL(18,1),
    d4 DECIMAL(38,1),
    ts timestamp time index,
);

INSERT INTO decimals values
(123,123*123,123*123*123,123*123*123*123,1000),
(456,456*456,456*456*456,456*456*456*456,2000),
(789,789*789,789*789*789,789*789*789*789,3000);

SELECT SUM(d1)::VARCHAR, SUM(d2)::VARCHAR, SUM(d3)::VARCHAR, SUM(d4)::VARCHAR FROM decimals;

INSERT INTO decimals VALUES ('0.1', '0.1', '0.1', '0.1', 4000), ('0.2', '0.2', '0.2', '0.2', 5000);

SELECT SUM(d1)::VARCHAR, SUM(d2)::VARCHAR, SUM(d3)::VARCHAR, SUM(d4)::VARCHAR FROM decimals;

DROP TABLE decimals;
